<?php
/*
Plugin Name: WPMUcryptographp
Plugin URI: http://www.2diabolos.com/blog/
Description: Uses the Cryptographp (http://www.cryptographp.com) library to add Captchas for comments or user registration.
Author: Thierry BOTTARO
Version: 1.0
Author URI: http://www.2diabolos.com/blog/
*/
/*  Copyright 
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
require_once(dirname(__FILE__).'/../../wp-config.php');
if(session_id() == "") session_start();

function cryptographp_menu() {
	if (function_exists('add_options_page')) {
		add_submenu_page('wpmu-admin.php', __('Cryptographp'), __('Cryptographp'), 8, 'wpmu-admin.php?page=cryptographp/admin.php'); 
	}
}
add_action('admin_menu', 'cryptographp_menu');

function cryptographp_comment_form() {
	include_once(dirname(__FILE__).'/cryptographp/cryptographp_form.php');
	cryptographp_form();
}
add_action( 'comment_form', 'cryptographp_comment_form' ) ;

function cryptographp_signup_blog_form ($errors) {
	if ( $errmsg = $errors->get_error_message('anti_robot') )
		echo '<tr class="error"> <th colspan="2">'.$errmsg.'</th> </tr>';
	echo '<tr><th></th><td>';
	cryptographp_comment_form();
	echo '</td></tr>';
}
add_action('signup_blogform','cryptographp_signup_blog_form' ) ;

function cryptographp_signup_user_form ($errors) {
	if ( $errmsg = $errors->get_error_message('anti_robot') ) {
		echo '<tr class="error"> <th colspan="2">'.$errmsg.'</th> </tr>';
		echo '<tr><th></th><td>';
		cryptographp_comment_form();
		echo '</td></tr>';
	}
}
add_action('signup_extra_fields','cryptographp_signup_user_form' ) ;

function cryptographp_preprocess_comment($incoming_comment) {
	require_once(dirname(__FILE__).'/cryptographp/crypt/cryptographp.fct.php');
	global $_POST;
	
	// Check if the comment is a trackback or pingback
	if ($incoming_comment['comment_type'] == 'trackback' || $incoming_comment['comment_type'] == 'pingback') {
		return $incoming_comment;
	}
	
	if (is_user_logged_in() && !$this->settings['logenable']) return $incoming_comment;
	
	//require_once(dirname(__FILE__).'/crypt/cryptographp.cfg.php');
	if (chk_crypt($_POST['securitycode'])) {
		return $incoming_comment;
	} else {
		wp_die (__('Error: Wrong anti-spam word.'));
	}
}
add_filter( 'preprocess_comment', 'cryptographp_preprocess_comment');    // add post comment post security code check


function cryptographp_filter_splog($result) {
	require_once(dirname(__FILE__).'/cryptographp/crypt/cryptographp.fct.php');
	global $_POST;
	if (!chk_crypt($_POST['securitycode'])) {
		$errors = $result['errors'];
		$errors->add('anti_robot','merci de vérifier le champ de vérification anti-robot');
		$result = array('user_name' => $result['user_name'], 'user_email' => $result['user_email'],	'errors' => $errors);
	}
	return $result;
}
add_filter( 'wpmu_validate_blog_signup', 'cryptographp_filter_splog');    // add  security code check

function cryptographp_filter_user($result) {
	if ( 'blog' != $_POST['signup_for'] ) {
		require_once(dirname(__FILE__).'/cryptographp/crypt/cryptographp.fct.php');
		if (empty($_POST['securitycode'])) {
			$errors = $result['errors'];
			$errors->add('anti_robot','Désolé, pour l\'activation d\'un simple login, il faut passer un test anti-robot ...');
			$result = array('user_name' => $result['user_name'], 'user_email' => $result['user_email'],	'errors' => $errors);
		} else if (!chk_crypt($_POST['securitycode'])) {
			$errors = $result['errors'];
			$errors->add('anti_robot','merci de vérifier le champ de vérification anti-robot');
			$result = array('user_name' => $result['user_name'], 'user_email' => $result['user_email'],	'errors' => $errors);
		}
	}
	return $result;
}
add_filter( 'wpmu_validate_user_signup', 'cryptographp_filter_user');    // add  security code check


function display_cryptographp() {// for compatibility
	cryptographp_comment_form();
}

?>